import * as React from "react";
export interface IAutoCompleteOption {
    id: number | string;
    name: string;
    data?: any;
    className?: string;
    style?: React.CSSProperties;
    prefixElement?: JSX.Element;
}
export declare function useThrottle<TValue>(value: TValue, limit: number, onValueChange?: (value: TValue) => void): TValue;
export declare function useRemoteOptions(remoteQuery?: (query: string) => Promise<IAutoCompleteOption[]>): {
    options: IAutoCompleteOption[];
    filter: string;
    setFilter: React.Dispatch<React.SetStateAction<string>>;
};
interface IAutoCompleteProps<TValue> {
    filter: string;
    onFilterChange: (v: string) => void;
    options: IAutoCompleteOption[];
    value: TValue;
    onValueChange: (o: TValue) => void;
}
declare type IAutoCompleteSelectProps<TM extends "single" | "multiple", TO> = {
    multiSelect: TM;
} & IAutoCompleteProps<TO>;
export declare const AutoComplete: React.FunctionComponent<IAutoCompleteSelectProps<"single", IAutoCompleteOption> | IAutoCompleteSelectProps<"multiple", IAutoCompleteOption[]>>;
export declare const AutoCompleteSingleInput: React.FunctionComponent<IAutoCompleteProps<IAutoCompleteOption>>;
export declare const AutoCompleteMultiInput: React.FunctionComponent<IAutoCompleteProps<IAutoCompleteOption[]>>;
export {};
