import * as React from "react";
import { IFormInputHTMLProps } from "../form";
export interface ICalendarInputProps extends IFormInputHTMLProps<React.InputHTMLAttributes<HTMLInputElement>> {
    /** The current date */
    date?: string;
    /** The 'wire' format of the date */
    format?: string;
    /** The 'display' format of the date (to use in the UI) */
    displayFormat?: string;
    /** The minimum date */
    min?: string;
    /** The maximum date */
    max?: string;
    /** Always show the calendar inline (not as a popup) */
    alwaysShowCalendar?: boolean;
    /** The icon to display */
    icon?: string;
    /** Is the control disabled */
    disabled?: boolean;
    /** Disable the ability to clear the current date */
    disableClear?: boolean;
    /** Callback when the selected date has changed */
    onDateChanged?: (date: string) => void;
}
export declare const CalendarInput: React.FC<ICalendarInputProps>;
