import * as React from "react";
import { IFormInputHTMLProps } from "../form";
export interface ISelectInput {
    focus: () => void;
    blur: () => void;
}
export interface ISelectInputOption {
    id: number | string;
    name: string;
}
export interface ISelectInputProps extends IFormInputHTMLProps<React.SelectHTMLAttributes<HTMLSelectElement>> {
    options: ISelectInputOption[];
    onOptionChange?: (selected: ISelectInputOption) => void;
    optionLabel?: string;
    enableOptionLabel?: boolean;
}
export declare const SelectInput: React.ForwardRefExoticComponent<ISelectInputProps & React.RefAttributes<ISelectInput>>;
