import * as React from "react";
export interface IBurgerMenu {
    toggleMenu: () => void;
    closeMenu: () => void;
    openMenu: () => void;
    isOpen: boolean;
}
export interface IBurgerMenuProps {
    buttonIcon?: string;
    bodySelector?: string;
    closeOnNavigate?: boolean;
    burgerButtonHidden?: boolean;
    onMenuToggle?: (sender: IBurgerMenu) => any;
    mode?: "push" | "slide";
    wrappingComponent?: React.ReactElement;
    children?: React.ReactElement<IBurgerMenuItemProps> | Array<React.ReactElement<IBurgerMenuItemProps>>;
}
export declare const BurgerMenu: React.ForwardRefExoticComponent<IBurgerMenuProps & React.RefAttributes<IBurgerMenu>>;
export interface IBurgerMenuItemProps extends React.HTMLAttributes<HTMLDivElement> {
    title: string;
    icon?: string;
    onClick?: () => void;
    style?: any;
    delayActionMs?: number;
    active?: boolean;
}
export declare const BurgerMenuItem: React.FC<IBurgerMenuItemProps>;
