import * as moment from "moment";
export declare type DateType = moment.Moment;
export declare type DayOfWeek = "Sun" | "Mon" | "Tue" | "Wed" | "Thu" | "Fri" | "Sat";
export interface IDateParts {
    day: number;
    month: number;
    year: number;
}
export declare namespace Dates {
    function getDaysArrayByMonth(month: number, year: number, minDate: string, maxDate: string): number[];
    function parseWireFormatDate(date: string): moment.Moment;
    function datePartsChanged(newState: Partial<IDateParts>, dateState: Partial<IDateParts>): boolean;
    function getDateParts(date: string, includeDate?: boolean): IDateParts & {
        date?: string;
    };
    function toDateFormat(s: Partial<IDateParts>): string;
    function getYearValues(minDate: string, maxDate: string, range?: number): number[];
    function getMonthValuesInRange(year: number, minDate: string, maxDate: string): {
        value: number;
        label: string;
    }[];
    function getMonthValues(): {
        value: number;
        label: string;
    }[];
    function startOfToday(): moment.Moment;
    function fallsWithinRange(mom: DateType, minDate: DateType, maxDate: DateType): boolean;
    function dateOrToday(date: string, formatString: string): moment.Moment;
    function dateOrEmpty(date: string, formatString: string): string;
    function dateOrNull(date: string, formatString: string): moment.Moment;
    function startOfMonth(mom: DateType): moment.Moment;
    function getMonth(mom: DateType): number;
    function getDayNumber(mom: DateType): number;
    function getYear(mom: DateType): number;
    function format(mom: DateType, formatString: string): string;
    function addMonth(mom: DateType, increment: number): moment.Moment;
    function addDay(mom: DateType, increment: number): moment.Moment;
    function getDayOfWeek(mom: DateType): DayOfWeek;
    function isDayOfWeek(mom: DateType, dayOfWeek: DayOfWeek): boolean;
}
