export declare namespace Utils {
    function keys(object: any): string[];
    function first<T>(items: T[], n: number): T[];
    function find<T>(items: T[], func: (t: T, index: number) => boolean): T;
    function each<T>(items: T[], func: (t: T, index: number) => void): void;
    function every<T>(items: T[], func: (t: T, index: number) => boolean): boolean;
    function some<T>(items: T[], func: (t: T, index: number) => boolean): boolean;
    function reduce<T, M>(items: T[], func: (m: M, t: T, index: number) => M, memo: M): M;
    function reject<T>(items: T[], func: (t: T) => boolean): T[];
    function filter<T>(items: T[], func: (t: T, index: number) => boolean): T[];
    function isArray(object: any): object is any[];
    function isString(object: any): object is string;
    function isFunction(object: any): object is Function;
    function isObject(object: any): boolean;
    function isEqual(object: any, other: any): boolean;
    function clone<T>(object: T): T;
    function range(start: number, stop: number, step?: number): number[];
    function isNullOrUndefined(value: any): value is (undefined | null);
}
